
	# Gets random images from google and sends them to the dev board
	# (C) 2008 Jason Hunt
	# nulluser@gmail.com
	
	use strict;
	use LWP::UserAgent;

	# Create a random string
	sub rand_str
	{
		my $len = shift;

		my @chars=('a'..'z','A'..'Z');
		my $str;

		foreach (1..$len) 
		{
			$str .= $chars[rand @chars];
		}
		return $str;
	}

	while(1)
	{
		#Google image search string
		my $search = &rand_str(3);

		print "Search string: $search\n";

	  	# Make url with embedded search string
	  	my $url = "http://images.google.com/images?hl=en&q=" . $search . "&um=1&ie=UTF-8&sa=N&tab=wi";

	  	my $ua = LWP::UserAgent->new;

		# Spoof user agent
	  	$ua->agent("Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.5a) Gecko/20030718");

		# Perform request
		my $content = $ua->get($url)->content or die("Unable to get data\n");

    	# Extract dynamic image data from results
    	# Starts with 'dyn.Img(' ends with  ')'
    	while ($content =~ m/dyn.Img\((.*?)\);/g)
		{
			print ".";

        	# Split into an array
			my @arr  = split /,(?!(?:[^",]|[^"],[^"])+")/, $1;

	 		my $thumb_url = substr (@arr[14], 1, length(@arr[14]) - 2) . 
    	    	            "?q=tbn:".
        	    	        substr (@arr[2], 1, length(@arr[2]) - 2);

			my $image_data = $ua->get($thumb_url)->content or die("Unable to get image\n");

			# Save jpeg file
			open FH, '>',"image.jpg" or die $!;
			binmode FH;
			print FH $image_data;
			close FH;

			# Call convert to save as ppm and resize
			`convert image.jpg -compress none -resize 132x132! -antialias image.ppm`;
		
			# Send Image to Board
			`perl send_image.pl`;

			# Clean Up
			`del image.jpg`;
			`del image.ppm`;

			sleep(5);
		}
	}

	__END__
