
	# Load ppm file and send it to the dev board
	# (C) 2008 Jason Hunt
	# nulluser@gmail.com

	use strict;
	use Win32::SerialPort;

	# Open comm port
	my $serial = Win32::SerialPort->new ('COM1') || die;
	
	# Setup comm port and write config
	$serial->baudrate(115200);
	$serial->parity("none");
	$serial->databits(8);
	$serial->stopbits(1);

	$serial->write_settings || die "Cannot write settings";

	# Open image file
	open f, '<',"image.ppm" or die $!;

	my $line;		# Current line
	my $x_size;		# X dimension of image
	my $y_size;		# Y dimension of image

	# Eat P3
	$line = <f>; 
	
	# Get dimension or comment
	$line = <f>; 

	# Eat comment line, if any
	if ($line =~ m/#/g)	{ $line = <f>; } 

	# Parse dimensions
	if ($line =~ m/([0-9]+) ([0-9]+)/g)
	{
		$x_size = $1; $y_size = $2;
	}

	# Eat max color
	$line = <f>; 

	print "Loading Image ($x_size x $y_size)\n";

	my @buff;		# Buffer for transcode data			
	my $i = 0;		# Index into buffer
	my @send;		# Transcoded buffer for serial send

	# Read image data and build send buffer
	while($line = <f>)
	{
		while ($line =~ m/([0-9]+)/g)
		{
			@buff[$i++] = $1;

			# Once we have six byte we can transcode and pack into send buffer
			if ($i == 6)
			{
				$i = 0;

				# Transcode and copy to send buffer
				push(@send, ($buff[0] & 0xf0) | ($buff[1] >> 4));
				push(@send, ($buff[2] & 0xf0) | ($buff[3] >> 4));
				push(@send, ($buff[4] & 0xf0) | ($buff[5] >> 4));
			}
		}
	}

	close FH;

	print "Sending data\n";
	
	$serial->write(pack("C*", @send));

	undef $serial; 
	undef @send;

	__END__

