/*
    YoctOS: LPC2148 Dev Board Operating System

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.        

    (C) Jason Hunt
    nulluser@gmail.com
        
    File: core.h
*/

 
typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int dword;

#ifndef CORE_H
#define CORE_H

#include "LPC214x.h"
#include "target.h"

#include "kernel/init.h"
#include "kernel/system.h"
#include "kernel/utility.h"
#include "kernel/printk.h"
#include "kernel/task.h"
#include "kernel/memory.h"
#include "kernel/signal.h"

#include "drivers/video.h"
#include "drivers/serial.h"
#include "drivers/interrupt.h"
#include "drivers/timer.h"

#include "../user/user.h"


#endif


