/*
    YoctOS: LPC2148 Dev Board Operating System

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.        

    (C) Jason Hunt
    nulluser@gmail.com
     
    File: serial.h
*/

#ifndef SERIAL_H
#define SERIAL_H

#define UART_NO_INRT    0x01
#define UART_RLS        0x06
#define UART_RX_READY   0x04
#define UART_TX_READY   0x02
#define UART_TIMEOUT    0x0c
#define UART_IIR_MASK   0x0f

#define TX_BUFFER_SIZE 32
#define RX_BUFFER_SIZE 32

typedef struct
{
    byte tx_buffer[TX_BUFFER_SIZE];
    volatile dword tx_head;
    volatile dword tx_tail;
    volatile dword tx_lock;
    volatile dword tx_bytes;
    
    byte rx_buffer[TX_BUFFER_SIZE];
    volatile dword rx_head;
    volatile dword rx_tail;
    volatile dword rx_bytes;

    volatile    byte sending;
    
} uart_type;

void serial_flush(void);

void serial_tx( byte ch );
byte serial_rx( byte *ch );
void serial_init( void );
void serial_uart0_isr( void )  __attribute__((naked));   
dword serial_tx_bytes( void );


#endif
