/*
    YoctOS: LPC2148 Dev Board Operating System

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.        

    (C) Jason Hunt
    nulluser@gmail.com
    
    File: target.h
*/

#ifndef TARGET_H
#define TARGET_H

// Compiler tricks

#define false   0
#define true    1

#define OK      0
#define FAIL    1

#define NULL ((void *) 0)       // Should never have to do this...

#define nop() {  asm volatile ("nop"); } 

#define SPIF 0x80               // SPI interrupt flag
#define PLOCK 0x0400            // PLL LOCK flag

#define FOSC	12000000UL      // Frequency of crystal
#define CCLK	(FOSC * 4)      // Frequency of core
#define PCLK	(CCLK)          // Peripheral clock (1:1 ratio)
#define FCCO	(CCLK * 4)     // Frequency of current controlled oscillator

#define timer_0_interval 10     // Timer 0 interval in ms

#define uart0_baud  19200      // Baud rate for uart zero
#define uart1_baud  115200     // Baud rate for uart one

#define led_0 (1<<24)          // Pin for led 0
#define led_1 (1<<25)          // Pin for led 1

// Pin setup for LCD

#define LCD_CLK		0x00000010		//Define P0.4 
#define LCD_DATA	0x00000040		//Define P0.6 
#define LCD_RESET 	0x00000020		//Define P0.5
#define LCD_CS		0x00000800		//Define P0.11


#endif





