/*
    YoctOS: LPC2148 Dev Board Operating System

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.        

    (C) Jason Hunt
    nulluser@gmail.com
     
    File: init.c
*/


#include <core.h>

/* Magic sequence for LPC2000 */
void pll_feed(void) 
{
    PLLFEED = 0xAA; 
    PLLFEED = 0x55;
}
/* End of feed */


/* Basic system init 
  Dependencies: None, should be first function called
*/
void system_init(void)
{
    // Fosc = 12 mhz
    // CCLK = 48 MHZ
    // M = 4
    // Fcco =  48 * 2 * 2
    // P = 2

  	PLLCFG = 0x23; pll_feed();       // 01 00011
	PLLCON = 0x01; pll_feed();       // Enable PLL 

	while(!(PLLSTAT & PLOCK));   // Wait for lock
 
	PLLCON = 0x03; pll_feed();       // Set PLL as clock source

	MAMCR = 0x02;                // Setup MAM
	MAMTIM = 0x04;
  
	VPBDIV = 0x01;               // Pclk = Cclk
}
/* End of system_init */


