/*
    YoctOS: LPC2148 Dev Board Operating System

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.        

    (C) Jason Hunt
    nulluser@gmail.com
     
    File: main.c
*/

#include <core.h>
 
/* Main */
int main( void )
{
    interrupt_disable_irq();

    // Init core
    system_init();         
    memory_init();
    signal_init();
    task_init();

    // Start drivers
    interrupt_init();      
    timer_init();          
    video_init();       
    serial_init();         

    interrupt_enable_irq();
    
    timer_enable(0, task_tick_isr);

    printk("\n\nKernel started\n");

    task_create(user_main, DEFAULT_STACK, 0);  
 
//    while(1);
}
/* End of main */


