/*
    YoctOS: LPC2148 Dev Board Operating System

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.        

    (C) Jason Hunt
    nulluser@gmail.com
  
    File: utility.c
*/


#include <core.h>


static dword rand_val;


/* Wait for ms milliseconds, dumb sleep */
void sleep( dword ms )
{
    dword i;

    for (i = 0; i < ms * 2600; i++) nop();
}
/* End of sleep */


/* Seed the PRS */
void srand(dword v)
{
    rand_val = v;
}
/* End of srand */


/* Return a randum number */
dword rand ( void )
{
    return(((rand_val = rand_val * 214013L + 2531011L) >> 16) & 0x7fff);
}
/* End of rand */


/* Halt for undefined instruction */
void fail_undef( void )
{
    panic("Fail: Undefined Instruction");
}
/* End of fail undef */


/* Halt for Prefetch abort */
void fail_pabt( void )
{
    panic("Fail: Prefecth Abort");
}
/* End of fail_pabt */


/* Halt for data abort */
void fail_dabt( void )
{
    panic("Fail: Data Abort");
}
/* End of fail_dabt */


