/*
    YoctOS: LPC2148 Dev Board Operating System

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.        

    (C) Jason Hunt
    nulluser@gmail.com
     
    File: main.c
*/

#include <core.h>

/* Wait for image over serial port and display */
void image_test( void )
{
  /*  unsigned char x = 0, y = 0, i;
    
    while(1)
    {
        // Set write window
        lcd_window (0, 0, VIDEO_X - 1, VIDEO_Y - 1);

        while(y < 132)
        {
            // Read 3 bytes for two pixels
            for (i = 0; i < 3; i++)
            {
                unsigned char t;
                serial_rx(&t);
                lcd_data(t);
            }

            x += 2;
                 
            if (x >= 132) { x = 0; y++; }
        }
        lcd_command(NOPP);

        y = 0;
    }  */
}
/* End of image_wait */




/* Blink Status led to indicate that system is running */
void system_led( dword t )
{
    // Activate as output
	IODIR1 |= led_0;

    while(1)
    {
     	IOCLR1 = led_0;
        task_sleep(t);
     	IOSET1 = led_0;
        task_sleep(t);
    }
}
/* End of system_led */


/* Display system stats on LCD */
void stat_monitor( dword t )
{
    while(1)
    {
        dword tm = timer_get_ticks();

        video_printk(0, 0, "Clock: %d   ", timer_get_ticks());
        video_printk(0, 1, "Memory: %d  ", memory_get_free());
        video_printk(0, 2, "Tasks %d    ", task_get_tasks());

        dword v = serial_tx_bytes();

        video_printk(0, 3, "tx %d  ", v);
        video_printk(0, 4, "ticks %d  ", timer_get_ticks() - tm);

        task_sleep(100);
    }
}
/* End of stat_monitor */



/* Helper for stress test */
int shared_function(int param)
{
    int i, r = 0;
    
    for (i = 0; i < param; i++)
        r++;    

    return(r);
}
/* End of shared function */


/* Stress test task */
void test_task(dword t)
{
    dword tm = 50 + (rand() % 50);
    
    while(1)
    {     
       // printk("Task: %d.  TID: %d\n", t, task_get_tid());

        int sum = 0, i, j;
        
        // Do some work
        for (i = 0; i < 100; i++)
            for (j = 0; j < 100; j++)
                sum++;
        
        // Call a function
        sum = shared_function (sum);
        
        // Check the work
        if (sum != 10000)
        {
            interrupt_disable_irq();

          //  printk("Sum: %d\n", sum);
          //  printk("Sum fail\n");
           // 
            while(1);
        }

        task_sleep(tm);
    }
}
/* End of test_task */

 
 
 
dword produced;
dword consumed;
 
dword n = 0;





void dumper (dword t)
{
    dword j;

    while(1)
    {
        dword tm = timer_get_ticks();
      
        dword r = 1000;

        while(r-- )
            printk("%c", t);

        // printk("\n\nElapsed: %d  (%c) \n", timer_get_ticks() - tm, t);

        video_printk(0, t-'A' + 5, "E: %d  (%c)  ", timer_get_ticks() - tm, t);

        // sleep(1000);
    }
        
}
 
 
 
void signal_prod( dword t )
{
    while(1)
    {
        dword i;
        
        for (i = 0; i < 1000; i++)
        {
            signal_wait(consumed);
            n++;
            signal_fire(produced);
        }
    }
        
}
 

void signal_cons( dword t )
{
    while(1)
    {
        dword i;
        
        for (i = 0; i < 1000; i++)
        {
            signal_wait(produced);
            printk("n: %d\n", n);
            signal_fire(consumed);
        }
        
    }
}




void user_main( void )
{
    task_create(system_led, 0x200, 500);   // Start the system running indicator
    task_create(stat_monitor, 0x200, 0);   // Start the stat display 

//    if ((consumed = signal_create(0)) == 0) panic("Fail create\n");
//    if ((produced = signal_create(1)) == 0) panic("Fail create\n");
 //   task_create(signal_cons, 0x100, 0);  
 //   task_create(signal_prod, 0x100, 0);  


    byte t;
    for (t = 0; t < 10; t++)
        task_create(dumper, 0x200, 'A' + t);  
 
 /*   unsigned int tmp;
    unsigned int num_tests = 10;        
          
    // Create some test tasks
    for (tmp = 0; tmp < num_tests; tmp++)
        task_create(test_task, 0x200, tmp);      */
    while(1);
}











 
